/*

reinhard@finalmedia.de
26.02.2014

BSD Lizenz

example-usage:  bit2fbdev -W 1024 -H 768 -w 1024 -h 768 -d 32 < house.bit > /dev/fb0

*/

#include <stdio.h>

#define MAXCOLS		4096

char c;
int count=0,i=0,x=0,total=0,d=0,rendered=0;
int fbcols,fbrows,fbbpp,b,datacols,datarows;
static char *usage = "usage: ./bit2fbdev -W input_with -H input_height -w width -h height -d bitdepth [-f frames] > /dev/fb0\n";


int main(int argc, char *argv[])
{
	for (i = 1; i < argc; i++) {
		switch (argv[i][0] == '-' ? argv[i][1] : '?') {
		case 'w':
			fbcols = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]);
			break;
		case 'h':
			fbrows = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]);
			break;
		case 'W':
			datacols = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]);
			break;
		case 'H':
			datarows = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]);
			break;
		case 'd':
			fbbpp = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]) / 8;
			break;
		default:
			fprintf(stderr, "%s", usage);
			return 0;
		}
	}



	if (fbcols <= 0 || fbcols > MAXCOLS || fbrows <= 0 || fbbpp <= 0 || datacols <=0 || datarows <=0) {
		fprintf(stderr, "%s", usage);
		return 1;
	}





	while (total<(fbcols*fbrows))
	{


		c=getc(stdin);

		for (x=0;x<8;x++) {

			count++;


			/* only render if width is not too big */
			if (count<=fbcols) {

				if ((c << x) & 0x80) {
					for (d=0;d<fbbpp;d++) { putc(255,stdout); }
				} else {
					for (d=0;d<fbbpp;d++) { putc(0,stdout); }
				};

			total++;

			}

			}

			if( count>=datacols ) {
			for(i=0;i<=(fbcols-count-(datarows*datacols));i++) {
			for (d=0;d<fbbpp;d++) { putc(0,stdout); }
			}

			count=0;
			fflush(stdout);


		};





	};

return 0;


}
